import 'dart:convert';
import 'dart:io';

/// http请求工具
class Http {
  // http协议
  String scheme;

  // 请求ip域名
  String host;

  // 端口
  int port;
  HttpClient httpClient = new HttpClient();

  Http({this.scheme, this.host, this.port});

  /// 构建http post请求
  Future<Map> post(String path, Map<String, dynamic> data) async {
    // 构建uri
    Uri uri =
        Uri(scheme: this.scheme, host: this.host, port: this.port, path: path);
    HttpClientRequest request = await httpClient.postUrl(uri);
    request.headers.add("token", 'DB7837207BF1BD3BAFCEF02CC0B9C665');
    // 添加post参数
    request.add(utf8.encode(json.encode(data)));
    // 发起请求
    HttpClientResponse response = await request.close();
    // 读取请求返回数据
    String responseBody = await response.transform(utf8.decoder).join();
    try {
      // 数据转map格式
      Map res = json.decode(responseBody);
      return res;
    } catch (e) {
      return {};
    }
  }
}
//
// void main() async {
//   int s = DateTime.now().millisecondsSinceEpoch;
//   Http http = Http(scheme: "https", host: "klz.test.xiaomanxiong.cn");
//   var a = await http.post("/api/V2.newyear/activity_rule", {});
//   print(DateTime.now().millisecondsSinceEpoch - s);
// }
